<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RoomInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RoomInfo extends AbstractStructArrayBase
{
    /**
     * The JPRoom
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RoomInfo[]
     */
    public $JPRoom;
    /**
     * Constructor method for ArrayOfJP_RoomInfo
     * @uses ArrayOfJP_RoomInfo::setJPRoom()
     * @param \StructType\JP_RoomInfo[] $jPRoom
     */
    public function __construct(array $jPRoom = array())
    {
        $this
            ->setJPRoom($jPRoom);
    }
    /**
     * Get JPRoom value
     * @return \StructType\JP_RoomInfo[]|null
     */
    public function getJPRoom()
    {
        return $this->JPRoom;
    }
    /**
     * This method is responsible for validating the values passed to the setJPRoom method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJPRoom method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJPRoomForArrayConstraintsFromSetJPRoom(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RoomInfoJPRoomItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RoomInfoJPRoomItem instanceof \StructType\JP_RoomInfo) {
                $invalidValues[] = is_object($arrayOfJP_RoomInfoJPRoomItem) ? get_class($arrayOfJP_RoomInfoJPRoomItem) : sprintf('%s(%s)', gettype($arrayOfJP_RoomInfoJPRoomItem), var_export($arrayOfJP_RoomInfoJPRoomItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The JPRoom property can only contain items of type \StructType\JP_RoomInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set JPRoom value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RoomInfo[] $jPRoom
     * @return \ArrayType\ArrayOfJP_RoomInfo
     */
    public function setJPRoom(array $jPRoom = array())
    {
        // validation for constraint: array
        if ('' !== ($jPRoomArrayErrorMessage = self::validateJPRoomForArrayConstraintsFromSetJPRoom($jPRoom))) {
            throw new \InvalidArgumentException($jPRoomArrayErrorMessage, __LINE__);
        }
        $this->JPRoom = $jPRoom;
        return $this;
    }
    /**
     * Add item to JPRoom value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RoomInfo $item
     * @return \ArrayType\ArrayOfJP_RoomInfo
     */
    public function addToJPRoom(\StructType\JP_RoomInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RoomInfo) {
            throw new \InvalidArgumentException(sprintf('The JPRoom property can only contain items of type \StructType\JP_RoomInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->JPRoom[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RoomInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RoomInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RoomInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RoomInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RoomInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JPRoom
     */
    public function getAttributeName()
    {
        return 'JPRoom';
    }
}
